angular.module('beamng.apps')
.directive('driftSensor', ['bngApi', 'StreamsManager', 'UiUnits', '$interval', function (bngApi, StreamsManager, UiUnits, $interval) {
  return {
    template: '<canvas width="300" height="165"></canvas>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs, ctrl) {
      var streamsList = ['sensors','electrics','wheelInfo','stats'];
      StreamsManager.add(streamsList);
/*
	  // [3] Use a variable to keep the settings
      var appSettings = null;

      // When DOM is ready and controllers are set up, get the stored settings.
      element.ready(function () {
        // [4] Call the getSettings() function of the controller
        ctrl.getSettings()
          .then(function (settings) {
            appSettings = settings;
          })
      });
*/	// unclear on settings.json implementation.

      scope.$on('$destroy', function () {
        StreamsManager.remove(streamsList);
        // [5] Optionally save the (possibly modified) app settings when done
        //ctrl.saveSettings(appSettings);
      });

      // can't seem to get this working
    var carImage = new Image(100, 200);
    carImage.src = 'modules/apps/DriftPoints/car.png';


	  var mouseOver = 0;
    var c = element[0]
      , appElement = c.parentElement.parentElement// it's buried two deep apparently :s
      , appLeft = appElement.offsetLeft
      , appTop = appElement.offsetTop
      , ctx = c.getContext('2d')
      , slX = 0
  		, slY = 0
  		, sdX = 0
  		, sdY = 0
  		, UITheme = 'dark'
  		, EX = 0
  		, EY = 0
  		// see recalculateScale function for ajustments that will take effect properly
  		, xScale = c.width/200 // scaledPos * scale(x or y) + Transformation;
  		, yScale = c.height/110
  		, xTransform = c.width/2
  		, yTransform = c.height/1.1
  		, middleDisplays = 'Points'
  		, gaugeDisplay = 'multipliers'
  		, angleInc = 2
      //UI calculations
      , gaugeRad = 84
      , gaugeThickness = 14
      , gaugeOutlineThickness = 1
      , gaugeFillThickness = gaugeThickness - 2
      , baseTextSize = gaugeFillThickness - 4
      , gaugeInRad = gaugeRad - (gaugeThickness / 2)
      , gaugeOutRad = gaugeRad + (gaugeThickness / 2)
      , gaugeTextColour = "RGBA(255,255,255,1)" // text on readouts and highlighted gauge values
      , gaugeShadowTextColour = "RGBA(255,255,255,0.5)" // label text and unhighlighted gauge values
      , gaugeShadowColour = "RGBA(0,0,0,0.8)" // backdrop shadow of gauge, fill of boxes
      , gaugeShadowOutlineColour = "RGBA(0,0,0,0.8)" // Line surrounding gauge and boxes
      , buttonHighlightFill = "RGBA(200,200,0,0.4)" // Fill inside hovered buttons
      , buttonHighlightStroke = "RGBA(200,200,0,1)" // Fill inside hovered buttons
      , buttonHighlightShadow = "Yellow" // Line surrounding hovered buttons
      , crashColour = "RGBA(255,0,0,0.5)" // flash colour for crashing
      , crashShadowColour = "red" // flash colour for crashing
      , slipRateColour = "blue" // colour shown for burning rubber
      , shadowBlur = 2 // how dispersed the shadows are
      , needleLimit = 94
    ;

    function changeTheme(themeName){
      switch(themeName){
        case 'dark':
          gaugeTextColour = "RGBA(255,255,255,1)";
          gaugeShadowTextColour = "RGBA(255,255,255,0.5)";
          gaugeShadowColour = "RGBA(0,0,0,0.8)";
          gaugeShadowOutlineColour = "RGBA(0,0,0,0.8)";
          break;
        case 'light':
          gaugeTextColour = "RGBA(255,255,255,1)";
          gaugeShadowTextColour = "RGBA(0,0,0,0.7)";
          gaugeShadowColour = "RGBA(255,255,255,0.5)";
          gaugeShadowOutlineColour = "RGBA(0,0,0,0.8)";
          break;
        default:
          gaugeTextColour = "RGBA(255,255,255,1)"; // text on readouts and highlighted gauge values
          gaugeShadowTextColour = "RGBA(0,0,0,0.7)"; // label text and unhighlighted gauge values
          gaugeShadowColour = "RGBA(255,255,255,0.5)"; // backdrop shadow of gauge, fill of boxes
          gaugeShadowOutlineColour = "RGBA(0,0,0,0.8)"; // Line surrounding gauge and boxes
          break;
      }
    }

    function applyTheme(context){
        context.fillStyle = gaugeShadowColour;
        context.strokeStyle = gaugeShadowOutlineColour;
    }

	  var posHist = [[0,0,false,0,0]] // [x,y bDrifting,slipAngle]
  		, posDiffHist = []
  		, posDiff = []
  		, airspeed = 0
  		, travelAngleDegs = 0
  		, yawDegs = 0
  		, slipAngle = 0
  		, slipAngleMag = 0
  		, lastSlipAngleMag = 0
  		, slipAngleMagDiffHist = []
  		, slipAngRad = 0
  		, absSlipAngleMag = 0
  		, overallSlip = 0
  		, gX2abs = 0
  		, lastG = 0
  		, newG = 0
  		, GDiffHist = [0]
      , GHist = [0]
      , currentLoops = []
      , loopHist = [[[0,0,false,0]]]
      , taps = []
	  ;

	  var bDrifting = false
      , driftLength = 0
      , driftLengthHist = [0]
      , longestDrift = 0
  		, gThreshold = 3 // 1/3 G to initiate a drift
  		, gCrashThreshold = 1 // initial crash threshold. Changes with speed.
  		, bCrashed = false
  		, angleCrashThreshold = 15 // threshold for change a crash can make to your facing.
  		, minDriftSpeed = 1
  		, minDriftAngle = 5 // minimum angle to be considered a drift.
  		, driftSide = 0
  		, driftTransfers = 0
  		, mostDriftTransfers = 0
  		, driftTransfersHist = [0,0]
      , donutCount = 0
  		, driftPoints = 0
  		, driftPointsHist = [0,0]
  		, mostDriftPoints = 0
  		, driftPointsTotal = 0
  		, eventMultiplier = 0
  		, multiplier = 0
  		, tappingBonus = 0
  		, multiplierColour = 0
  		, DriftingIndiColour = 'Black'
	  ;

	  // remeber to change the app:resize if you want it all to work
	  //ctx.setTransform(c.width/200, 0, 0, c.height/200, c.width/2,c.height/2);
	  recalculateScale();
	  ctx.setTransform(xScale, 0, 0, yScale, xTransform,yTransform);

	  var fontStyle = 'normal'
		, fontVariant = 'normal'
		, fontWeight = 'bold'
		, fontSize = 10
		, fontFamily = '"Lucida Console"'
		, pointsBox = new box(
      [0,-61,'Center',6,1],// position, alignment, and screen number
      ['Points', baseTextSize * 2,gaugeTextColour,'0000'], // content
      [gaugeShadowColour], // style
      [false,function(){}], // is button
      false // is Oval
    )
		, totalBox = new box(
      [0,-15,'Center',6,1],
      ['Total', baseTextSize * 2,gaugeTextColour,'0000'],
      [gaugeShadowColour],
      [true,resetTotal]
    )
		, lastPointsBox = new box(
      [-22,-38,'Center',6,1],
      ['', baseTextSize * 1.5,gaugeTextColour,'0000'],
      [gaugeShadowColour]
    )
		, mostPointsBox = new box(
      [22,-38,'Center',6,1],
      ['', baseTextSize * 1.5,gaugeTextColour,'0000'],
      [gaugeShadowColour]
    )
		, multiplierBox = new box(
      [pointsBox.bottomRight()[0],pointsBox.bottomRight()[1],'BottomLeft',1,1],
      ['0', baseTextSize * 1.3,gaugeTextColour,'00'],
      [gaugeShadowColour]
    )
		, UIButtonBox = new box(
      [70,-6,'Center'],
      [' ', baseTextSize * 1.3,gaugeTextColour,'0'],
      ["white"],
      [true,toggleTheme],
      true
    )
		, angleDispBox = new box(
      [0,0,'Center',0,0],
      [' ', baseTextSize * 1.3,gaugeTextColour,'00'],
      ["white"],
      [true,toggleGaugeDisplay],
      true
    )
		, displayToggleBox = new box(
      [0,-38,'Center',1,1],
      [' ', baseTextSize * 1.3,gaugeTextColour],
      ["RGBA(200,200,0,1)"],
      [true,toggleDisplay]
    )
		, testBox = new box(
      [40,-20,'Center',0,1],
      ['TEST BOX', 10,gaugeTextColour],
      [gaugeShadowColour],
      [true,function(){}],
      false
    )
		, displayFeedbackBox = new box(
      [0,-38,'Center',3,0],
      ['', baseTextSize * 1.3,gaugeTextColour],
      ['black']
    )
    , debugGraphBox = new box(
      [0,-25,'Center',3,3],
      ['', 50, gaugeTextColour, '000',renderDebugGraphs],
      [gaugeShadowColour]
    )
    , driftMapBox = new box(
      [0,-25,'Center',3,2],
      ['', 50, gaugeTextColour, '000',renderDriftPath],
      [gaugeShadowColour]
    )
    , arrowDownBoxXY = driftMapBox.bottomLeft()
    , screenDownBox = new box(
      [arrowDownBoxXY[0],arrowDownBoxXY[1],'BottomRight',1,0],
      ['v', baseTextSize,gaugeTextColour,'0'],
      ["black"],
      [true,function(){toggleScreen(false)}],
      false
    )
    , arrowUpBoxXY = screenDownBox.topLeft()
    , screenUpBox = new box(
      [arrowUpBoxXY[0],arrowUpBoxXY[1],'BottomLeft',1,0],
      ['^', baseTextSize,gaugeTextColour,'0'],
      ["black"],
      [true,function(){toggleScreen(true)}],
      false
    )
    , zoomInXY = driftMapBox.topLeft()
    , zoomInBox = new box(
      [zoomInXY[0],zoomInXY[1],'TopLeft',1,2],
      ['+', baseTextSize,gaugeTextColour,'0'],
      ["black"],
      [true,function(){driftPathScreenZoom(true)}],
      false
    )
    , zoomOutXY = zoomInBox.bottomLeft()
    , zoomOutBox = new box(
      [zoomOutXY[0],zoomOutXY[1],'TopLeft',1,2],
      ['-', baseTextSize,gaugeTextColour,'0'],
      ["black"],
      [true,function(){driftPathScreenZoom(false)}],
      false
    )
    , carBox = new box(
      [0,0,'Center',0,2],
      ['', baseTextSize, gaugeTextColour,'',renderCar],
      ["Grey"]
    )
    , boxes = [
        testBox,
        pointsBox,
        totalBox,
        lastPointsBox,
        mostPointsBox,
        multiplierBox,
        UIButtonBox,
        displayToggleBox,
        displayFeedbackBox,
        angleDispBox,
        screenUpBox,
        screenDownBox,
        zoomInBox,
        zoomOutBox,
        carBox,
        driftMapBox,
        debugGraphBox
      ]
    , currentScreen = 1
    , noOfScreens = 3
    , driftPathZoom = 0.75
	  , buttons = []
    ;

    displayFeedbackBox.bHide(true); // feedback window
    for(var i = 0; i < boxes.length; i++) {
      var _b = boxes[i];

      if(_b.bButton()){
        buttons.unshift(_b);
      }
    }

    function setVisibleScreen(number){
      currentScreen = number;
      for(var i = 0; i < boxes.length; i++){
        var _b = boxes[i];
        if(_b.screenNumber() == currentScreen){
          _b.bHide(false); // needs to be seen
        }else{
          if(_b.screenNumber() > 0){
            // this allows us to have things that show up regardless in the <1 screens
            _b.bHide(true);
          }
        }
      }
    }

    function toggleScreen(bPrevious){
      if(bPrevious){
        currentScreen++;
      }else{
        currentScreen--;
      }
      if(currentScreen > noOfScreens){
        currentScreen = 1;
      }else if(currentScreen <= 0){
        currentScreen = noOfScreens;
      }
      setVisibleScreen(currentScreen);
      displayFeedbackBox.text(''); // doesn't show feedback
    }
    setVisibleScreen(1); // to initialize the box states

    function driftPathScreenZoom(bUp){
      if(bUp){
        driftPathZoom = driftPathZoom * 1.5;
      }else{
        driftPathZoom = driftPathZoom / 1.5;
      }
      if(driftPathZoom <= 0.12){
        driftPathZoom = 0.12;
      }else if(driftPathZoom > 3){
        driftPathZoom = 3
      }
      displayFeedbackBox.text(''); // doesn't show feedback
    }

    function renderCar(context,box){
      var _brushSave = saveBrush(context);

      var _width = box.width();
      var _height = box.height();
      var _tl = box.topLeft();

      context.lineWidth = 0.2;
      context.strokeStyle = 'black';
      context.fillStyle = 'black';
      context.fillRect(_tl[0], _tl[1] + ((_height / 16) * 1), _width, _height / 4);
      context.strokeRect(_tl[0], _tl[1] + ((_height / 16) * 1), _width, _height / 4);

      context.fillRect(_tl[0], _tl[1] + ((_height / 16) * 10), _width, _height / 4);
      context.strokeRect(_tl[0], _tl[1] + ((_height / 16) * 10), _width, _height / 4);

      context.strokeStyle = 'black';
      context.fillStyle = 'grey';
      context.fillRect(_tl[0] + ((_width / 12) * 1), _tl[1], ((_width / 12) * 10), _height);
      context.strokeRect(_tl[0] + ((_width / 12) * 1), _tl[1], ((_width / 12) * 10), _height);

      context.lineWidth = 0.4;
      context.strokeRect(_tl[0] + ((_width / 8) * 2), _tl[1] + (_height / 8), ((_width / 8) * 4), (_height / 12) * 7 );

      restoreBrush(context,_brushSave);
    }

    function renderDriftPath(context,box){
          var brushSave = saveBrush(context);
          // More stroke calls but more detail
          context.shadowColor = 'black';
          context.shadowBlur = 0;

            ctx.beginPath();
          var oX = box.center()[0];
          var oY = box.center()[1];
          //ctx.lineWidth = driftPathZoom * 3;
          ctx.lineCap = 'square';

          ctx.moveTo(oX,oY);
          var _drift = posHist[0][2];
          var xNormaliser = -((posHist[0][0] * driftPathZoom) - oX);
          var yNormaliser = -((posHist[0][1] * driftPathZoom) - oY);
          ctx.beginPath();
          for(var i = 1; i < posHist.length; i++) {

            var nPX = -((posHist[i][0] * driftPathZoom) + xNormaliser);
            var nPY = (posHist[i][1] * driftPathZoom) + yNormaliser;
            if( bInsideBox([nPX,nPY],box) ){
                // if current pos says drift
                if(posHist[i][2]){
                  ctx.strokeStyle = "RGBA(0,200,0,0.8)";
                }else{ // if not
                  ctx.strokeStyle = "RGBA(255,0,0,0.8)";
                };

                ctx.lineWidth = driftPathZoom * (Math.abs(posHist[i][3] / 8) + 0.4);
                ctx.lineTo(nPX,nPY);
                ctx.stroke();
                ctx.beginPath();
            }
            ctx.moveTo(nPX,nPY);
          }


          for(var loopInd = 0; loopInd < loopHist.length; loopInd++){
            var loop  = loopHist[loopInd];
            ctx.beginPath();
            ctx.moveTo(-((loop[0][0] * driftPathZoom) + xNormaliser),(loop[0][1] * driftPathZoom) + yNormaliser);
            for(var i = 1; i < loop.length; i++) {
              var nPX = -((loop[i][0] * driftPathZoom) + xNormaliser);
              var nPY = (loop[i][1] * driftPathZoom) + yNormaliser;
              if( bInsideBox([nPX,nPY],box) ){
                  // if current pos says drift
                  if(loop[i][2]){
                    ctx.strokeStyle = "RGBA(0,100,200,0.8)";
                  }else{ // if not
                    ctx.strokeStyle = "RGBA(255,0,0,0.8)";
                  };

                  ctx.lineWidth = driftPathZoom * (Math.abs(loop[i][3] / 8) + 0.4);
                  ctx.lineTo(nPX,nPY);
                  ctx.stroke();
                  ctx.beginPath();
              }
              ctx.moveTo(nPX,nPY);
            }
          }

          ctx.strokeStyle = "RGBA(200,200,0,0.8)";
          ctx.lineCap = 'round';

          for(var i = 0; i < taps.length; i++){
            var nPX = -((taps[i][0] * driftPathZoom) + xNormaliser);
            var nPY = (taps[i][1] * driftPathZoom) + yNormaliser;

            if( bInsideBox([nPX,nPY],box) ){
              //ctx.lineWidth = driftPathZoom * (taps[i][4] / 10);
              ctx.lineWidth = driftPathZoom * 5;
              ctx.beginPath();
              ctx.moveTo(nPX,nPY);
              ctx.lineTo(nPX + 0.1,nPY + 0.1);
              ctx.stroke();
            }
          }


      // the little car icon
      restoreBrush(context,brushSave);
      carBox.center([0,0]);
      carBox.width(9 * driftPathZoom);
      carBox.height(14 * driftPathZoom);
      angleContext(oX,oY,((yawDegs) * Math.PI / 180));
      carBox.render(ctx,false,false,false);
      restoreContextAngle();

      restoreBrush(context,brushSave);
      zoomInBox.topLeft(box.topLeft);
      zoomOutBox.topLeft(zoomInBox.bottomLeft);
      zoomInBox.render(ctx,true,true,true);
      zoomOutBox.render(ctx,true,true,true);
    }

    function renderDebugGraphs(context,box){
      var brushSave = saveBrush(context);
      context.shadowBlur = 0; // reset

      var bX = box.bottomLeft()[0];
      var bY = box.bottomLeft()[1];
      var bW = box.width();
      var bH = box.height();
      var widthMargin = bW / 10;
      var heightMargin = bH / 10;
      var oX = bX + widthMargin;
      var oY = bY - heightMargin;

// draw the graph origins
      context.beginPath();
      context.strokeStyle = "RGBA(255,255,255,0.8)";
      context.lineWidth = 2;
      context.lineCap = 'round';
      context.moveTo(oX,oY);
      context.lineTo(oX,oY - (heightMargin * 9));
      context.stroke(); // draw line
      context.beginPath();
      context.moveTo(oX,oY);
      context.lineTo(oX + (widthMargin * 9),oY);
      context.stroke(); // draw line

  // draw G line

          context.beginPath();
      		context.strokeStyle = "RGBA(255,255,0,0.8)";
      		context.lineWidth = 2;
      		context.lineCap = 'round';
      		context.moveTo(oX,oY - Math.abs(GDiffHist[0]));
          var GGraphStep = (widthMargin * 9) / (GDiffHist.length - 1);
          var GMaximum = Math.max.apply(null,GDiffHist);//20;
          if(GMaximum < 2){GMaximum = 2;}
          var GThreshLineY = (heightMargin * 9) * (gCrashThreshold / GMaximum);

      		for(var i = 1; i < GDiffHist.length; i++) {
      			context.lineTo(oX + (i * GGraphStep),oY - ((Math.abs(GDiffHist[i]) /  GMaximum) * (heightMargin * 9) ) ); // negative because of the render of the UI... pixels render left to right/ top to bottom
      		}
      		context.stroke(); // draw line

          context.fillStyle = "RGBA(255,255,0,0.8)";
          setFontSize(context,widthMargin * 0.5);
          context.lineWidth = 0.5;
          for(var i = 0; i < 5; i++) {
            var nY = oY - (((heightMargin * 8) / 4) * i);
            context.fillText(
              (i * (GMaximum / 5)).toFixed(1),
              oX - (widthMargin / 2),
              nY
            ); // negative because of the render of the UI... pixels render left to right/ top to bottom
            context.beginPath();
            context.moveTo(oX,nY);
            context.lineTo(
              oX + (widthMargin * 9),
              nY
            ); // negative because of the render of the UI... pixels render left to right/ top to bottom
            context.stroke();
          }

          setFontSize(context,widthMargin * 0.75);
          context.fillText(
            'Shock Gs',
            oX + ((widthMargin * 9) / 2),
            oY - (heightMargin * 7)
          );

          context.beginPath();
          context.strokeStyle = "RGBA(255,0,0,0.8)";
          context.moveTo(oX,oY - GThreshLineY);
          context.lineTo(
            oX + (widthMargin * 9),
            oY - GThreshLineY
          );
          context.stroke();

          context.fillText(
            gCrashThreshold.toFixed(2),
            //oX + ((widthMargin * 9) / 2),
            oX + widthMargin ,
            oY - GThreshLineY + heightMargin
          );

/*
      		context.beginPath();
      		context.strokeStyle = "RGBA(255,100,0,0.8)";
      		context.moveTo(oX,oY - gCrashThreshold);
      		context.lineTo(oX + (GDiffHist.length * 20),oY - gCrashThreshold);
      		context.stroke(); // draw line
*/

      restoreBrush(context,brushSave);
    }


/*
	  function box(posArray,content){
		//				([x,y,align,padding],[someText,Size],bool bButton)
		var _x = posArray[0];
		var _y = posArray[1];
		var _text = content || 'I did not set anything';

		var _center = [_x,_y];

		var _width = ctx.measureText(_text).width;

		//
		// add functions
		//

		var _topLeft = [_x - (_width / 2),_y - 5];

		function topLeft(valArray){
			if(typeof valArray !== 'undefined'){
				_topLeft = [0,0];
			}else{
				return _topLeft;
			}
		}

		function center(valArray){
			if(typeof valArray !== 'undefined'){
				_center = valArray;
			}else{
				return _center;
			}
		}

		function width(val){
			if(typeof val !== 'undefined'){
				_width = val;
			}else{
				return _width;
			}
		}

		function text(val){
			if(typeof val !== 'undefined'){
				_text = val;
				_width = ctx.measureText(_text).width;
			}else{
				return _text;
			}
		}

		function render(context){
			// if the box is set to be highlighted... save old stroke information to return to afterwards




			// Actually render the box

				context.fillRect(_topLeft[0], _topLeft[1], _width, 20);

				context.strokeRect(_topLeft[0], _topLeft[1], _width, 20);
				context.fillStyle = "white";
				context.fillText(content,_center[0],_center[1]);

		}

		return{
			// properties with functions in here
			topLeft: topLeft,
			center: center,
			width: width,
			text: text,
			render: render
		}
	  }
*/
  function box(posArray,content,style,buttonArray,isOval){
		//				([x,y,align,padding],[someText,Size],[true,func],bool isOval)
		// [posArray]
		var _x = posArray[0];
		var _y = posArray[1];
		var _align = posArray[2] || 'TopLeft';
		var _padding = posArray[3] || 0;
    var _screen = posArray[4] || 0; // all screens

		// [content]
		var _text = content[0] || '';
		var _fontSize = content[1] || 10;
		var _fontColour = content[2] || 'White';
    var _minTextLength = content[3] || '';
    var _otherContent = content[4] || function(){};

    // [Style]
    var _fillColour = style[0] || 'RGBA(0,0,0,0)';
    var _strokeColour = style[1] || 'Black';
    var _lineWidth = style[2] || 1;
    var _shadowColour = style[3] || 'Black';
    var _shadowBlur = style[4] || 0;
    //var _inheritStyle = false; // integrated into the render function

		var _t;
		var _l;
		var _b;
		var _r;
		var _center;
		var _topLeft;
		var _bottomLeft;
		var _topRight;
		var _bottomRight;
		var _width = ((_fontSize / 1.55) * _text.length) + _padding;
		var _height = _fontSize + _padding;
		var _bHover = false;
		var _button = buttonArray || [false,function(){}];
		var _bOval = isOval || false;
    var _bHide = false;

  /*  if(_button){
      buttons.push(this);
    }*/ // seems to break things

		switch(_align){
			case 'TopLeft':
				_t = _y;
				_l = _x;break;
			case 'TopRight':
				_t = _y;
				_r = _x; break;
			case 'BottomLeft':
				_b = _y;
				_l = _x;break;
			case 'BottomRight':
				_b = _y;
				_r = _x; break;
			case 'Center':
				_center = [_x,_y]; break;
			default:
				_t = _y;
				_l = _x; break;
		}

		function calcDimentions(){
			switch(_align){
				case 'TopLeft':
					_b = _t + _height;
					_r = _l + _width;
					_center = [_l + (_width/2),_t + (_height/2)]; break;
				case 'TopRight':
					_b = _t + _height;
					_l = _r - _width;
					_center = [_l + (_width/2),_t + (_height/2)]; break;
				case 'BottomLeft':
					_t = _b - _height;
					_r = _l + _width;
					_center = [_l + (_width/2),_t + (_height/2)]; break;
				case 'BottomRight':
					_t = _b - _height;
					_l = _r - _width;
					_center = [_l + (_width/2),_t + (_height/2)]; break;
				case 'Center':
					_b = _center[1] + (_height / 2);
					_t = _center[1] - (_height / 2);
					_r = _center[0] + (_width / 2);
					_l = _center[0] - (_width / 2); break;
				default:
					_b = _t + _height;
					_r = _l + _width;
					_center = [_l + (_width/2),_t + (_height/2)]; break;
			}

			_topLeft = [_l,_t];
			_bottomLeft = [_l,_b];
			_topRight = [_r,_t];
			_bottomRight = [_r,_b];
		}


		// called to complete dimentions
		calcDimentions();



		//
		// add functions
		//
/*
    function inheritStyle(val){
      if(typeof val !== 'undefined'){
        _inheritStyle = val;
      }else{
        return _inheritStyle;
      }
    }
*/
    function screenNumber(val){
      if(typeof val !== 'undefined'){
        _screen = val;
      }else{
        return _screen;
      }
    }

    function width(val){
      if(typeof val !== 'undefined'){
        _width = val;
        calcDimentions();
      }else{
        return _width;
      }
    }

    function widthAdjust(){
      if(_text.length > _minTextLength.length){
        width( ((_fontSize / 1.55) * _text.length) + _padding );
      }else{
        width( ((_fontSize / 1.55) * _minTextLength.length) + _padding );
      }
    }
    widthAdjust(); // to sort the width out for any initial content

    function height(val){
      if(typeof val !== 'undefined'){
        _height = val;
        calcDimentions();
      }else{
        return _height;
      }
    }

		function fontColour(val){
			if(typeof val !== 'undefined'){
				_fontColour = val;
			}else{
				return _fontColour;
			}
		}

    function fontSize(val){
			if(typeof val !== 'undefined'){
				_fontSize = val;
				_height = _fontSize + _padding;
        widthAdjust();
				//calcDimentions(); // happens in width function
			}else{
				return _fontSize;
			}
		}

		function fillColour(val){
			if(typeof val !== 'undefined'){
				_fillColour = val;
			}else{
				return _fillColour;
			}
		}

    function strokeColour(val){
      if(typeof val !== 'undefined'){
        _strokeColour = val;
      }else{
        return _strokeColour;
      }
    }

    function lineWidth(val){
      if(typeof val !== 'undefined'){
        _lineWidth = val;
      }else{
        return _lineWidth;
      }
    }

    function shadowColour(val){
      if(typeof val !== 'undefined'){
        _shadowColour = val;
      }else{
        return _shadowColour;
      }
    }

    function shadowBlur(val){
      if(typeof val !== 'undefined'){
        _shadowBlur = val;
      }else{
        return _shadowBlur;
      }
    }

		function top(val){
			if(typeof val !== 'undefined'){
				_t = val;
				//calcDimentions();
			}else{
				return _t;
			}
		}

		function bottom(val){
			if(typeof val !== 'undefined'){
				_b = val;
				//calcDimentions();
			}else{
				return _b;
			}
		}

		function left(val){
			if(typeof val !== 'undefined'){
				_l = val;
				//calcDimentions();
			}else{
				return _l;
			}
		}

		function right(val){
			if(typeof val !== 'undefined'){
				_r = val;
				//calcDimentions();
			}else{
				return _r;
			}
		}


		function topLeft(valArray){
			if(typeof valArray !== 'undefined'){
				top(valArray[1]);
				left(valArray[0]);
				calcDimentions();
			}else{
				return _topLeft;
			}
		}

		function bottomLeft(valArray){
			if(typeof valArray !== 'undefined'){
				bottom(valArray[1]);
				left(valArray[0]);
				calcDimentions();
			}else{
				return _bottomLeft;
			}
		}

		function topRight(valArray){
			if(typeof valArray !== 'undefined'){
				top(valArray[1]);
				right(valArray[0]);
				calcDimentions();
			}else{
				return _topRight;
			}
		}

		function bottomRight(valArray){
			if(typeof valArray !== 'undefined'){
				bottom(valArray[1]);
				right(valArray[0]);
				calcDimentions();
			}else{
				return _bottomRight;
			}
		}

		function center(valArray){
			if(typeof valArray !== 'undefined'){
				_center = valArray;
				calcDimentions();
			}else{
				return _center;
			}
		}

		function padding(val){
			if(typeof val !== 'undefined'){
				_padding = val;
				widthAdjust();
				//calcDimentions(); // happens in width function
			}else{
				return _padding;
			}
		}

		function text(val){
			if(typeof val !== 'undefined'){
				_text = val;
        widthAdjust();
				//calcDimentions(); // happens in width function
			}else{
				return _text;
			}
		}

		function bButton(val){
			if(typeof val !== 'undefined'){
				_button[0] = val;
			}else{
				return _button[0];
			}
		}

    // not required since a function is  passed as a reference anyway
    /*function buttonAction(fnc){
      if(typeof fnc !== 'undefined'){
        _button[1] = fnc;
      }else{
        return _button[1];
      }
    }*/

		function bHover(val){
			if(typeof val !== 'undefined'){
				_bHover = val;
			}else{
				return _bHover;
			}
		}

		function bOval(val){
			if(typeof val !== 'undefined'){
				_bOval = val;
			}else{
				return _bOval;
			}
		}

    function bHide(val){
      if(typeof val !== 'undefined'){
        _bHide = val;
      }else{
        return _bHide;
      }
    }

    function loadBrushSettings(context){
      context.strokeStyle = _strokeColour;
      context.fillStyle = _fillColour;
      context.shadowColor = _shadowColour;
      context.shadowBlur = _shadowBlur;
      context.lineWidth = _lineWidth;
      setFontSize(context,_fontSize);
    }


    function renderText(context){
      // seperate if it gets to be more complex
      var brushSave = saveBrush(context);

      context.fillStyle = _fontColour;
      context.fillText(_text,_center[0],_center[1]);

      restoreBrush(context,brushSave);
    }

		function render(context,_bFill,_bStroke,_inheritStyle){
      if(!_bHide){
    			// save current brush settings to be restored after we are done
    			var brushSave = saveBrush(context);

          if(!_inheritStyle){
            loadBrushSettings(context); // load up the settings for this specific box
          }
          setFontSize(context,_fontSize); // forced in the absence of a more elegant method of filtering between inherited traits

    			if(typeof _bFill === 'undefined'){
    				_bFill = true;
    			}
    			if(typeof _bStroke === 'undefined'){
    				_bStroke = true;
    			}

    			if(_bHover){
    				context.strokeStyle = buttonHighlightStroke;
            context.fillStyle = buttonHighlightFill;
            context.shadowBlur = 10;
    				context.shadowColor = buttonHighlightShadow;
    			}

    			if(_bOval){
    					context.beginPath();
    				context.arc(_center[0],_center[1],_width / 2,2 * Math.PI,0,1);
    				// Actually render the oval
    				if(_bFill){
    					context.fill();
    				}else{ // we need to make some indication of a button hover
    					if(_bHover){
    						context.fill();
    					}
    				}
    				if(_bStroke){
    					context.stroke();
    				}
    			}else{
    				// Actually render the box
    				if(_bFill){
    					context.fillRect(_l, _t, _width, _height);
    				}else{
    					if(_bHover){
    						context.fillRect(_l, _t, _width, _height);
    					}
    				}
    				if(_bStroke){
    					context.strokeRect(_l, _t, _width, _height);
    				}
    			}

          _otherContent(context,this);
          renderText(context);

          // reset the bruch back to how it was before we messed with it here.
    			restoreBrush(context,brushSave);
      }
		}

		return{
			// properties with functions in here
			topLeft: topLeft,
			bottomLeft: bottomLeft,
			topRight: topRight,
			bottomRight: bottomRight,
			center: center,
			height: height,
			width: width,
			padding: padding,
			fontSize: fontSize,
			fontColour: fontColour,
			fillColour: fillColour,
      strokeColour: strokeColour,
			bButton: bButton,
      buttonAction: _button[1],
			bHover: bHover,
      bHide: bHide,
      screenNumber: screenNumber,
      text: text,
      innerContent: _otherContent,
			render: render
		}
  }

  function saveBrush(context){
    return [
      context.strokeStyle,
      context.fillStyle,
      context.shadowColor,
      context.shadowBlur,
      context.lineWidth,
      context.font
    ];
  }

  function restoreBrush(context,brushSave){
    context.strokeStyle = brushSave[0];
    context.fillStyle = brushSave[1];
    context.shadowColor = brushSave[2];
    context.shadowBlur = brushSave[3];
    context.lineWidth = brushSave[4];
    context.font = brushSave[5];
  }

	  function setFontSize(context2d,sizeNum){
		fontSize = sizeNum;
		compileFont(context2d);
	  }

	  function setFontWeight(context2d,weight){
		fontWeight = weight;
		compileFont(context2d);
	  }

	  function compileFont(context2d){
		context2d.font =
			fontStyle + ' ' +
			fontVariant + ' ' +
			fontWeight + ' ' +
			fontSize + 'px' + ' ' +
			fontFamily
		;
	  }


	  // To sort the wheels from their messy non alphabetised list.
    var sortedWheelIndices = null;
    var _sortedWheelIndicesFunc = function (wheelInfo){ // TODO: duplicated in WeightDistribution app
      function getWheelNames(wheelInfo){
        var names=[];
        for(var i in wheelInfo)
          names.push(wheelInfo[i][0]);
        return names;
      }

      function wheelNamesToIndices(wheelInfo, wheelNames){
        var indices=[];
        for(var i in wheelNames)
          for(var j in wheelInfo)
            if (wheelNames[i] == wheelInfo[j][0])
              indices.push(j);
        return indices;
      }
      return wheelNamesToIndices(wheelInfo, getWheelNames(wheelInfo).sort()); // alphabetical sort suits our needs: FL < FR < RL < RR
    };

    // display info functions
	  function resetTotal() {
  		driftPointsHist = [0,0];
  		driftTransfersHist = [0,0]
  		driftPointsTotal = 0;
  		mostDriftPoints= 0;
  		mostDriftTransfers = 0;
      longestDrift = 0;
      driftLengthHist = [0];
      posHist = [posHist[0]];
      displayFeedbackBox.text('Reset');
	  }

	  function clearCurrentPoints() {
  		driftPoints = 0;
  		driftTransfers = 0;
  		tappingBonus = 0;
  		eventMultiplier = 0;
      currentLoops.length = 0;
	  }

	  function addPoints() {
  		if(bDrifting) {
  			driftPoints = driftPoints + (0.1 * multiplier);
  			//driftPoints = driftPoints++;
  		} else if(!bDrifting && ((driftPoints > 0) || (eventMultiplier > 0))) {
  			if((driftPoints > 20) && (airspeed > minDriftSpeed) && !bCrashed){
  				driftPointsHist.unshift(driftPoints * eventMultiplier);
  				if(driftPointsHist.length >= 100){
  					driftPointsHist.pop(); // removes the last element
  				}
  				mostDriftPoints = Math.max.apply(null,driftPointsHist);
  				driftPointsTotal += driftPointsHist[0]; // add last points to total
  				// check if we hit a new record for drift transfers
  				driftTransfersHist.unshift(driftTransfers);
  				mostDriftTransfers = Math.max.apply(null,driftTransfersHist);

          // add loops to the loopHist array to be rendered later
          for(var i = 0; currentLoops.length > 0; i++){
            loopHist.unshift(currentLoops.pop())
          }
  			}
  			clearCurrentPoints();
  		} else {
  			// nothing
  		}
	  }

    function driftLengthMon() {
      if(bDrifting) {
        driftLength = driftLength + Math.abs( Math.sqrt( Math.pow(posDiff[0],2) + Math.pow(posDiff[1],2) ) );
      } else {
        if((driftLength > 0)  && (airspeed > minDriftSpeed) && (!bCrashed)) {
          driftLengthHist.unshift(driftLength);
          longestDrift = Math.max.apply(null,[longestDrift,driftLength]);
        }
        driftLength = 0;
      }
    }

	  function bSlipping(wheel){
      // if wheel slip rate is < 2
  		if(wheel[5] > 2)
  			return true;
  		else
  			return false;
	  };

	  function getAngle(_opp,_adj){
  		return Math.atan2(_opp,_adj);
	  }

    function distance(_p1,_p2){
      var _dAdj = _p2[0] - _p1[0];
      var _dOpp = _p2[1] - _p1[1];

  		return Math.sqrt((_dAdj * _dAdj) + (_dOpp * _dOpp));
	  }

    function absDistance(_p1,_p2){
      return Math.abs(distance(_p1,_p2));
	  }

    function arraysEqual(a, b) {
      if (a === b) return true;
      if (a == null || b == null) return false;
      if (a.length != b.length) return false;

      // If you don't care about the order of the elements inside
      // the array, you should sort both arrays here.

      for (var i = 0; i < a.length; ++i) {
        if (a[i] !== b[i]) return false;
      }
      return true;
    }

	  var driftDowntime = 0;
	  var downtimeCheckInt = 0.1; //secs
	  var gripping = true;
	  function checkDriftDowntime() {
  		if(gripping) {
  			driftDowntime += downtimeCheckInt;
  		} else {
  			driftDowntime = 0;
  		}
	  }

	  var lastDeformedBeams = 0;
	  function updateDeformedBeams(newDeformedBeams) {
      lastDeformedBeams = newDeformedBeams;
	  }

	  var flashTick = 0; // used for the flashing parts of the display
	  function flashTickFunc(){
      flashTick = Math.abs(flashTick - 1);
	  }

	  function feedbackTickFunc(_timems,_switchRefArray){
  		_switchRefArray[0] = 1;
  		setTimeout(function(){_switchRefArray[0] = 0},_timems);
	  }

	  function toggleTheme() {
  		if(UITheme == 'light'){
  			UITheme = 'dark';
  		}else{
  			UITheme = 'light';
  		};
      changeTheme(UITheme);
      displayFeedbackBox.text(UITheme);
	  }

	  function toggleGaugeDisplay() {
  		if(gaugeDisplay == 'multipliers'){
  			gaugeDisplay = 'degrees';
  		}else{
  			gaugeDisplay = 'multipliers';
  		};
      displayFeedbackBox.text(gaugeDisplay);
	  }

	  function toggleDisplay() {
  		if(middleDisplays == 'Points'){
  			middleDisplays = 'Transitions';
  		}else if(middleDisplays == 'Transitions'){
  			middleDisplays = 'Drift Length';
  		}else if(middleDisplays == 'Drift Length'){
        middleDisplays = 'Points';
      }
      displayFeedbackBox.text(middleDisplays);
	  }

    // functions for recalculating the app if moved
	  function bAppMoved() {
  		if(appElement.offsetLeft != appLeft){ return true;}
  		if(appElement.offsetTop != appTop){ return true;}
  		return false;
	  }

	  function recalculateScale() {
  		xScale = c.width/200; // scaledPos * scale(x or y) + Transformation;
  		yScale = c.height/110;
  		xTransform = c.width/2;
  		yTransform = c.height/1.1;
	  }

	  function recalculateAppPos(){
	    appLeft = appElement.offsetLeft;
      appTop = appElement.offsetTop;
	  }

	  function appPosMonitor() {
  		if(bAppMoved()){
  			recalculateAppPos();
  		}
	  }

// donut sensor functions

    var driftSensorSide = 0;
    var driftStartAngle = 0;
    var driftStartPos = [0,0];
    var leftThreshold = false;
    var threshDist = 10;

    var threshIndex = 1;
    var driftStartIndex = 2;

    function setDriftStart(){
      driftSensorSide = driftSide;
      driftStartAngle = yawDegs; // store start angle
      driftStartPos = posHist[0];
      leftThreshold = false;
    }

    function addDonut(){
      donutCount++;
      setDriftStart();
    }

    function bCrossingPath(){
      threshIndex = 100; // a high number to avoid looping
      driftStartIndex = 0;

      // work out where the most recent drift started
      for(var i = 10; i < posHist.length; i += 5){
        //if(!posHist[i][2]){
        if(arraysEqual(posHist[i],driftStartPos)){
          driftStartIndex = (i - 1); // return the last  one because we were drifting then
          break;
        }
      }

      // check the last position in this drift that is outside of the trheshold (to stop and endless loop)
      for(var i = 0; i < driftStartIndex; i++){
        if(absDistance(posHist[0],posHist[i]) > threshDist){
          threshIndex = i;
          break;
        }
      }


      for(var i = threshIndex; i <= driftStartIndex; i++){
        if(absDistance(posHist[i],posHist[0]) < (threshDist / 2)){
          currentLoops.unshift(posHist.slice(0,i)); // stored for rendering later.
          return true;
        }
      }

      return false; // we didn't find a moment that wasn't before the current drift
    }

    function donutSensor(){
      var bCrossing = false;
      if(driftSide != driftSensorSide){
        setDriftStart(); // a way to sense loops with transitions would be good.
      }else if(driftSensorSide != 0){
        if(airspeed > 5){
          if( (!leftThreshold) && (absDistance(driftStartPos,posHist[0]) > threshDist) ){
            leftThreshold = true;
          }
          var bCrossing = bCrossingPath();
          if(leftThreshold && bCrossing){
          //if( leftThreshold ){
              addDonut();
          }
        }
      }else{

      }

/*
      ctx.fillStyle = 'white';
      setFontSize(ctx,5);
      ctx.fillText('test stuff', -60, -25);
      ctx.fillText(driftStartIndex, -60, -20);
      ctx.fillText(threshIndex, -60, -15);
      ctx.fillText(bCrossing, -60, -10);
*/
/*
      if(driftSide != 0){
        var angDiff = yawDegs - driftStartAngle;
        // The one degree is a buffer to avoid a loop that adds points continuously
        if(driftSide == 1){
          if( ((angDiff > 1) && (angDiff < 5)) || ((angDiff > -359) && (angDiff < -355)) ){ // within 5 degs
            //addDonut();
          }
        }else{
          if( ((angDiff > -5) && (angDiff < -1)) || ((angDiff > 355) && (angDiff < 359)) ){
            //addDonut();
          }
        }
      }
*/
    }

	  // running loops
	  setInterval(appPosMonitor,1000);
	  setInterval(addPoints,100);
	  setInterval(checkDriftDowntime,downtimeCheckInt * 1000);
	  setInterval(flashTickFunc,333);

  scope.$on('streamsUpdate', function (event, data) {
		// sort the wheels
		var wheels = data.wheelInfo;

		if (!sortedWheelIndices || (wheels && wheels.length != sortedWheelIndices.length))
		  sortedWheelIndices = _sortedWheelIndicesFunc(wheels);

		var FL = wheels[sortedWheelIndices[0]];
		var FR = wheels[sortedWheelIndices[1]];
		var RL = wheels[sortedWheelIndices[2]];
		var RR = wheels[sortedWheelIndices[3]];

		var wheelCount = 0;
		/* wheels format:
		0  wd.name
		1  wd.radius
		2  wd.wheelDir
		3  w.angularVelocity
		4  w.lastTorque
		5  drivetrain.wheelInfo[wd.wheelID].lastSlip
		6  wd.lastTorqueMode
		7  brake pressure
		8  a constant of some kind?
		*/

		// Glean angle of travel from position whcih is taken and compared from moment to moment
		airspeed = data.electrics.airspeed;

		// store history of positions
		posHist.unshift([data.sensors.position.x,data.sensors.position.y,bDrifting]);
		if(posHist.length >= 1000){ posHist.pop() };

		posDiff = [posHist[0][0] - posHist[1][0],posHist[0][1] - posHist[1][1]];
    driftLengthMon(); //  calculate distance travelled and add to the current drift length if bDrifting
		// store history of position differences
		posDiffHist.unshift(posDiff);
		if(posDiffHist.length >= 100){ posDiffHist.pop() };


		travelAngleDegs = getAngle(posDiff[0],posDiff[1]) * 180 / Math.PI;
		if(travelAngleDegs < 0) {travelAngleDegs += 360;}
		yawDegs = Math.abs(data.sensors.yaw - Math.PI) * 180 / Math.PI;
		slipAngle = travelAngleDegs - yawDegs;
		if(airspeed < minDriftSpeed){slipAngle = 0;}
		if(slipAngle < 0){slipAngle += 360;}

		//move old data into reference and replace with new
		// old
		lastSlipAngleMag = slipAngleMag;
		// new
		if(slipAngle > 180){
			slipAngleMag = slipAngle - 360;
		} else {
			slipAngleMag = slipAngle;
		}
		slipAngleMagDiffHist.unshift(slipAngleMag - lastSlipAngleMag);
		if(slipAngleMagDiffHist.length >= 100){
			slipAngleMagDiffHist.pop(); // removes the last element
		}

		absSlipAngleMag = Math.round(Math.abs(slipAngleMag));


    //donutSensor(); //  check if we have done a donut

    GHist.unshift( Math.sqrt((data.sensors.gx2 * data.sensors.gx2) + (data.sensors.gy2 * data.sensors.gy2)) / 9.81);
		if(GHist.length >= 100){
			GHist.pop(); // removes the last element
		}

    GDiffHist.unshift(GHist[0] - GHist[1]);// are these negative?????
		if(GDiffHist.length >= 100){
			GDiffHist.pop(); // removes the last element
		}

		gX2abs = Math.abs(data.sensors.gx2); // Gs being pull along the X axis of the car (relative)


		// Drifting starts if atleast one of the two rear wheels are slipping and the Gs in the x axis are significant
		if( (bSlipping(RL) || bSlipping(RR)) && (absSlipAngleMag > minDriftAngle) && (gX2abs > gThreshold) && (!bCrashed)) {
			bDrifting = true;
			gripping = false;
		}
		// Drifting then stops if both wheels aren't slipping or you are going less than 1mph.
		if(  !( bSlipping(RL) || bSlipping(RR) ) || (airspeed < minDriftSpeed) ){
			gripping = true;
			if(driftDowntime > 0.2) {
				bDrifting = false;
			}
		}

		overallSlip = (RL[5] + RR[5]) / 2;

		// if we hit something fairly hard the drift is not counted
    // we check the last 10 readings to account for missing in a single frame
		if(data.stats.beams_deformed != lastDeformedBeams) {
			for(var i = 0; i < 10; i++){
				if((GDiffHist[i] > gCrashThreshold) || (GDiffHist[i] < -gCrashThreshold))
				{
					bDrifting = false;
					bCrashed = true;
					setTimeout(function(){bCrashed = false},2000);
					break;
				}
			}

			if(!bCrashed && bDrifting){
				tappingBonus++;
        posHist[0][4] = data.stats.beams_deformed - lastDeformedBeams;
        taps.unshift(posHist[0]);
				// because you've just tapped something without totaling the car or losing the drift.
			}

			updateDeformedBeams(data.stats.beams_deformed);
		}

		// calculate a multiplier based on current speed and slip angle. the faster the drift with more angle, the better
		var speedMultiplier = airspeed / 4; // every 4 mph increases the mulitplier by 1
		var rubberMultiplier = overallSlip / 4;
/*		if(speedMultiplier < 1){
			speedMultiplier = 1;
		}
*/		gCrashThreshold = (airspeed / 10) / 2; // 1/2 G per 10mph because the GForce info is in newtons?
		// Logic for drift transfer multipliers (going from one into another)
		if(bDrifting) {
			if(driftSide == 0) {
				if(slipAngleMag > 0) {driftSide = 1;} else {driftSide = -1;}
				driftTransfers++;
			}

			if((driftSide == 1) && (slipAngleMag < -minDriftAngle)) {
				driftSide = -1;
				driftTransfers++;
			} else if((driftSide == -1) && (slipAngleMag > minDriftAngle)) {
				driftSide = 1;
				driftTransfers++;
			} else {
				// no change in drift side.
			}
		} else {
			driftSide = 0;
			//driftTransfers = 0; //  made 0 when points are allocated
		}

		multiplier = rubberMultiplier + speedMultiplier + Math.abs(slipAngleMag / 10); // add proximity to objects as a modifier!!!
		eventMultiplier = tappingBonus + driftTransfers + Math.floor(driftLength / 100) + currentLoops.length; // every 100m drift adds 1 to the multiplier
		multiplierColour = Math.round((255 / 14) * multiplier) + 127;
									//(target max / expected max) * variable with the expected max

		// setting alpha value based on multiplier to show a good drift by intensity of colour!
		if(bDrifting) {
			var _greenvalue = 0.2 + ((airspeed / 25) * 0.4) + ((overallSlip / 20) * 0.4); //maxes out at 40mph
			DriftingIndiColour = "RGBA(0,200,0," + _greenvalue.toFixed(3) + ")";
		} else {
			DriftingIndiColour = "RGBA(200,0,0,0.8)";
		}

		var _slipPerc = (overallSlip / 18);
		var displaySlipAngle = slipAngleMag; // limited to 90deg either way to not break UI look
		if(!bDrifting) {displaySlipAngle = 0}
		if(displaySlipAngle > 90) {displaySlipAngle = 90;}
		if(displaySlipAngle < -90) {displaySlipAngle = -90;}
    posHist[0][3] = displaySlipAngle;
		//position of slip line on end on UI
		slX = Math.sin(displaySlipAngle * Math.PI / 180) * needleLimit;
		slY = Math.cos(displaySlipAngle * Math.PI / 180) * needleLimit;
		//position of slip dot marker on guage
		sdX = Math.sin(displaySlipAngle * Math.PI / 180) * gaugeRad;
		sdY = Math.cos(displaySlipAngle * Math.PI / 180) * gaugeRad;

		//Render display
		ctx.shadowBlur = 0;
    setFontSize(ctx,10);
		ctx.textAlign = "center";
    ctx.textBaseline = "middle";

    ctx.clearRect(-100,-100,200,200);
    // ctx.clearRect(0, 0, 300, 300);

    // Circles
    //ctx.strokeStyle = "RGBA(0,0,0,1)";
    //ctx.lineWidth = 5;
    //ctx.fillStyle = "RGBA(0,0,0,0.8)";

    donutSensor(); //  check if we have done a donut

		//Gauge shadow
			ctx.beginPath();
		if(bDrifting){
			ctx.shadowBlur = shadowBlur;
			ctx.shadowColor = slipRateColour;
		}
		ctx.strokeStyle = gaugeShadowColour;
		ctx.lineCap = 'round';
		ctx.lineJoin = 'round';
		ctx.lineWidth = gaugeThickness;
		ctx.arc(0,0,gaugeRad,0 * Math.PI,1 * Math.PI,1);
		if(bCrashed && flashTick){ctx.shadowBlur = shadowBlur;ctx.shadowColor = crashShadowColour;}
		ctx.stroke();

			ctx.beginPath();
		ctx.strokeStyle = "RGBA(0," + (_slipPerc * 100).toFixed(0) + "," + (_slipPerc * 255).toFixed(0) + "," + (0.5 + (_slipPerc * 0.3)).toFixed(0) + ")";
		if(bCrashed && flashTick){ctx.strokeStyle = crashColour; ctx.shadowBlur = shadowBlur;ctx.shadowColor = crashShadowColour;}
		ctx.lineWidth = (gaugeOutlineThickness + (_slipPerc * (1 + gaugeOutlineThickness))).toFixed(0); if(bCrashed && flashTick){ctx.lineWidth = 3;}
		ctx.arc(0,0,gaugeInRad,0 * Math.PI,1 * Math.PI,1);
		ctx.stroke();
			ctx.beginPath();
		ctx.arc(0,0,gaugeOutRad,0 * Math.PI,1 * Math.PI,1);
		ctx.stroke();
		ctx.clearRect(-100,0,200,10);
		ctx.shadowBlur = 0; // reset

		//Gauge fill
		ctx.beginPath();
		ctx.strokeStyle = DriftingIndiColour; //"RGBA(255,0,0,0.8)"
		ctx.lineWidth = gaugeFillThickness;
		//ctx.lineCap = 'round';
		var arcDir = 0; if(displaySlipAngle < 0){arcDir = 1};
		ctx.arc(0,0,gaugeRad,1.5 * Math.PI,(displaySlipAngle * Math.PI / 180) + (1.5 * Math.PI),arcDir);
		ctx.moveTo(sdX,-sdY);
		ctx.lineTo(slX,-slY); // negative because of the render of the UI... pixels render left to right/ top to bottom
		ctx.stroke();
		ctx.shadowBlur = 0; // reset

		setFontWeight(ctx,'bold');
		ctx.fillStyle = gaugeTextColour;


		if(gaugeDisplay == 'multipliers'){
      angleDispBox.text('x' + (Math.abs(displaySlipAngle) / 10).toFixed(0));
      ///textAtAngle(,angleDispBox[4],angleDispBox[5],(displaySlipAngle * Math.PI / 180))
		} else if(gaugeDisplay == 'degrees'){
      angleDispBox.text(Math.abs(displaySlipAngle).toFixed(0));
			//textAtAngle(,angleDispBox[4],angleDispBox[5],(displaySlipAngle * Math.PI / 180))
		};
    angleDispBox.center([sdX,-sdY]);
    angleDispBox.render(ctx,false,false,false);


		// Multiplier markers
		if(gaugeDisplay == 'degrees'){
			angleInc = 1.5;
		};
		if(gaugeDisplay == 'multipliers'){
			angleInc = 2;
		};
		for(var i = angleInc; i < 9; i = i + angleInc) {
			//positions of text on guage
			// right side
			var _angle = i * 10;
			setFontWeight(ctx,'normal');
			ctx.fillStyle = gaugeShadowTextColour;
			ctx.shadowBlur = 0; // reset
			if((displaySlipAngle >= _angle) && flashTick) {
				ctx.shadowBlur = 5;
				ctx.shadowColor = "yellow";
				setFontWeight(ctx,'bold');
				ctx.fillStyle = gaugeTextColour;
			}

			if(gaugeDisplay == 'degrees'){
				textAtAngle(_angle,(Math.sin(_angle * Math.PI / 180) * gaugeRad), -(Math.cos(_angle * Math.PI / 180) * gaugeRad), (_angle * Math.PI / 180));
			};
			if(gaugeDisplay == 'multipliers'){
				textAtAngle('x' + i.toFixed(0),(Math.sin(_angle * Math.PI / 180) * gaugeRad), -(Math.cos(_angle * Math.PI / 180) * gaugeRad), (_angle * Math.PI / 180))
			};

			// left side
			setFontWeight(ctx,'normal');
			ctx.fillStyle = gaugeShadowTextColour;
			ctx.shadowBlur = 0; // reset
			if((displaySlipAngle <= -_angle) && flashTick) {
				ctx.shadowBlur = 5;
				ctx.shadowColor = "yellow";
				setFontWeight(ctx,'bold');
				ctx.fillStyle = gaugeTextColour;
			}

			if(gaugeDisplay == 'degrees'){
				textAtAngle(_angle,-(Math.sin(_angle * Math.PI / 180) * gaugeRad), -(Math.cos(_angle * Math.PI / 180) * gaugeRad), -(_angle * Math.PI / 180));
			};
			if(gaugeDisplay == 'multipliers'){
				textAtAngle('x' + i.toFixed(0),-(Math.sin(_angle * Math.PI / 180) * gaugeRad), -(Math.cos(_angle * Math.PI / 180) * gaugeRad), -(_angle * Math.PI / 180))
			};

		}



		ctx.shadowBlur = 0; // reset



		//center of gauge
			// background
		ctx.fillStyle = gaugeShadowColour;
		setFontWeight(ctx,'bold');

		ctx.fillStyle = gaugeShadowColour;
		if(bDrifting){
			ctx.shadowBlur = shadowBlur;
			ctx.shadowColor = slipRateColour;
		}
		ctx.strokeStyle = "RGBA(0," + (_slipPerc * 100).toFixed(0) + "," + (_slipPerc * 255).toFixed(0) + "," + (0.5 + (_slipPerc * 0.3)).toFixed(0) + ")";
		if(bCrashed && flashTick){ctx.strokeStyle = crashColour; ctx.shadowBlur = shadowBlur;ctx.shadowColor = crashShadowColour;}
		ctx.lineWidth = (gaugeOutlineThickness + (_slipPerc * (gaugeOutlineThickness))).toFixed(0); if(bCrashed && flashTick){ctx.lineWidth = 3;}


		ctx.fillStyle = gaugeShadowColour;

// render boxes
    //testBox.render(ctx,true,true,true);
    pointsBox.text(driftPoints.toFixed(0));
    pointsBox.render(ctx,true,true,true);
    multiplierBox.text(eventMultiplier.toFixed(0));
    multiplierBox.bottomLeft(pointsBox.bottomRight());
    multiplierBox.render(ctx,true,false,true);
    totalBox.text(driftPointsTotal.toFixed(0));
    totalBox.render(ctx,true,true,true);

    driftMapBox.render(ctx,true,true,true);
    debugGraphBox.render(ctx,true,true,true);
    //ctx.drawImage(carImage, 0, 0); // seems like I'm not sure how to implement this
    displayToggleBox.render(ctx,true,true,false);

    if(middleDisplays == 'Points') {
      lastPointsBox.text(driftPointsHist[0].toFixed(0));
      mostPointsBox.text(mostDriftPoints.toFixed(0));
    }else if(middleDisplays == 'Transitions') {
      lastPointsBox.text(driftTransfersHist[0].toFixed(0));
      mostPointsBox.text(mostDriftTransfers);
    }else if(middleDisplays == 'Drift Length') {
      lastPointsBox.text(driftLength.toFixed(0) + 'm');
      mostPointsBox.text(longestDrift.toFixed(0) + 'm');
    }
    lastPointsBox.render(ctx,true,true,true);
    mostPointsBox.render(ctx,true,true,true);

    screenUpBox.render(ctx,true,true,true);
    screenDownBox.render(ctx,true,true,true);

// specific UI button .... could be refactored into a colour update and strict render
    ctx.strokeStyle = "RGBA(255,255,255,0.8)";
		ctx.fillStyle = "white";
		if(UITheme == 'light') {
			ctx.strokeStyle = "RGBA(0,0,0,0.8)";
			ctx.fillStyle = "black";
		}
    UIButtonBox.render(ctx,true,true,true);


		ctx.shadowBlur = 0; // reset
    if(currentScreen == 1){
  		// box labels
  		ctx.textAlign = "left";
      ctx.textBaseline = "top";
  		setFontSize(ctx,baseTextSize * 0.75);
  		ctx.fillStyle = gaugeShadowTextColour;
  		ctx.fillText('Points', pointsBox.topLeft()[0], pointsBox.topLeft()[1]);
  		ctx.fillText('Total', totalBox.topLeft()[0], totalBox.topLeft()[1]);
  		ctx.fillText('Last', lastPointsBox.topLeft()[0], lastPointsBox.topLeft()[1]);
  		ctx.fillText('Most', mostPointsBox.topLeft()[0], mostPointsBox.topLeft()[1]);
  		ctx.fillText('X', multiplierBox.topLeft()[0], multiplierBox.topLeft()[1]);
    }

		ctx.textAlign = "center";
    ctx.textBaseline = "middle";
    // render feedback box
    displayFeedbackBox.render(ctx,true,true,false); // bHide is toggled by click functions


		ctx.fillStyle = gaugeTextColour;
/*
    setFontSize(ctx,baseTextSize * 0.75);
    ctx.fillText(tappingBonus, -60, -40);
    ctx.fillText(currentLoops.length, -65, -45);
    ctx.fillText(driftSide, -40, -40);

    ctx.fillText('t:' + tappingBonus + ':' + taps.length, 55, -20);
    ctx.fillText(airspeed.toFixed(0), 55, -15);
    ctx.fillText('tr:' + driftTransfers, 55, -10);
    ctx.fillText(driftLength.toFixed(0), 55, -5);
    ctx.fillText('Os' + currentLoops.length, 55, -1);
*/
    //ctx.fillText(driftStartAngle.toFixed(0), -60, -25);
    //ctx.fillText(yawDegs.toFixed(0), -60, -20);
/*		ctx.fillText(displayFeedback[0], -60, -20);
		ctx.fillText(middleDisplays, -60, -20);
		ctx.fillText(UIButtonBox[7].toFixed(0), 60, -40);
		ctx.fillText(totalBox[7].toFixed(0), 40, -40);
		ctx.fillText(highlightCount(), 60, -20);
		ctx.fillText(buttons.length, 50, -20);
		ctx.fillText(mouseOver, 60, 0);
		ctx.fillText(EX + ':' + EY, 40, -10);
		ctx.fillText(overallSlip.toFixed(2), 0, 0);
		ctx.fillText(appElement.nodeName, 60, -40);
		ctx.fillText(appLeft + ',' + appTop, 60, -20);
		ctx.fillText(EX + ',' + EY, 60, 0);
*/

	 });


	 // Event listeners

	c.addEventListener('click', function(event) {
		// TODO build the function desired into the button box array.
    for(var i = 0; i < buttons.length; i++){
      var _b = buttons[i];
      if(_b.bHover()){
        if((_b.screenNumber() == currentScreen) || (_b.screenNumber() <= 0)){
          _b.buttonAction();
          // display text should be set inside triggered function

          if(displayFeedbackBox.text() != ''){
            //displayFeedbackBox.center([(EX - xTransform) / xScale,(EY - yTransform) / yScale]); // set the feedback box to cursor location
            displayFeedbackBox.center(_b.center()); // set the feedback box to box location
            displayFeedbackBox.bHide(false);
            setTimeout(function(){displayFeedbackBox.bHide(true)},500);
          }
        }
      }
    }
	});

  function bInsideBox(pos,box){
    var _tl = box.topLeft();
    var _br = box.bottomRight();
    if(
      (pos[0] > _tl[0]) &&
      (pos[0] < _br[0]) &&
      (pos[1] > _tl[1]) &&
      (pos[1] < _br[1])
    ){
      return true;
    }else{
      return false;
    }
  }

	function boxDimentionsToPixels(box) {
    var _array = [];
    var _xy = box.topLeft();
    _array = [(_xy[0] * xScale) + xTransform, (_xy[1] * yScale) + yTransform, box.width() * xScale, box.height() * yScale];
    return _array;
	}

	function hoverHighlight() {
		for(var i = 0; i < buttons.length; i++) {
			var bpDims = boxDimentionsToPixels(buttons[i]); // x0 y1 l2 h3
        if((EX > bpDims[0]) && (EX < (bpDims[0] + bpDims[2]))){
  				if((EY > bpDims[1]) && (EY < (bpDims[1] + bpDims[3]))){
              buttons[i].bHover(1);
  					//break; // we should only have 1 hihlight at a time.
  				}else{
              buttons[i].bHover(0);
  				}
  			}else{
            buttons[i].bHover(0); //  should have a glowing about it
            // I think this method is less efficient than a full sweep and only a positive scan (not scanning for negative cases)
  			}
		}
	}

	function clearHighlights() {
		for(var i = 0; i < buttons.length; i++){
        buttons[i].bHover(0);
		}
	}

	function highlightCount() {
		var _count = 0;
		for(var i = 0; i < buttons.length; i++) {
        if(buttons[i].bHover()){_count++}
		}
		return _count;
	}

	function textAtAngle(text,x,y,angle){
		ctx.save();
		ctx.translate(x,y);
		ctx.rotate(angle);
		var _oldTextAlign = ctx.textAlign;
		ctx.textAlign = "center";

		ctx.fillText(text, 0, 0);

		ctx.restore();
		ctx.textAlign = _oldTextAlign;
	}

  function angleContext(x,y,angle){
    ctx.save();
    ctx.translate(x,y);
    ctx.rotate(angle);
  }

  function restoreContextAngle(){
    ctx.restore();
  }

	c.addEventListener('mouseover', function(event) {
		mouseOver = 1;
	});

	c.addEventListener('mouseout', function(event) {
		mouseOver = 0;
	});

	c.addEventListener('mousemove', function(event) {
		EX = event.pageX - appLeft;
    EY = event.pageY - appTop;
		if(mouseOver){
			//clearHighlights(); // if used insdead of cycling through all buttons and they hit boxes, we might improve performance of the app.
			hoverHighlight();
		}
	});

	  scope.$on('VehicleChange', function (event, data) {
        sortedWheelIndices = null;
      });

      scope.$on('app:resized', function (event, data) {
		c.width = data.width;
        c.height = data.height;
        //ctx.setTransform(c.width/200, 0, 0, c.height/200, c.width/2,c.height/2);

		recalculateScale();

        ctx.setTransform(xScale, 0, 0, yScale, xTransform,yTransform);
      });

    }
  };
}]);
